diff --git a/Silicon/Socionext/SynQuacer/Include/Platform/DramInfo.h b/Silicon/Socionext/SynQuacer/Include/Platform/DramInfo.h
new file mode 100644
index 000000000000..f7691bdade4a
--- /dev/null
+++ b/Silicon/Socionext/SynQuacer/Include/Platform/DramInfo.h
@@ -0,0 +1,30 @@
+/** @file
+  Data structure for passing DRAM information from lower level firmware
+
+  Copyright (c) 2017, Linaro Ltd. All rights reserved.<BR>
+
+  This program and the accompanying materials are licensed and made available
+  under the terms and conditions of the BSD License which accompanies this
+  distribution.  The full text of the license may be found at
+  http://opensource.org/licenses/bsd-license.php.
+
+  THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT
+  WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
+
+**/
+
+#ifndef _SYNQUACER_PLATFORM_DRAM_INFO_H_
+#define _SYNQUACER_PLATFORM_DRAM_INFO_H_
+
+typedef struct {
+  UINT64            Base;
+  UINT64            Size;
+} DRAM_INFO_ENTRY;
+
+typedef struct {
+  UINT32            NumRegions;
+  UINT32            Reserved;
+  DRAM_INFO_ENTRY   Entry[3];
+} DRAM_INFO;
+
+#endif
diff --git a/Silicon/Socionext/SynQuacer/Include/Ppi/DramInfo.h b/Silicon/Socionext/SynQuacer/Include/Ppi/DramInfo.h
new file mode 100644
index 000000000000..6453e121317d
--- /dev/null
+++ b/Silicon/Socionext/SynQuacer/Include/Ppi/DramInfo.h
@@ -0,0 +1,64 @@
+/** @file
+  DRAM info PPI to retrieve DRAM information from lower level firmware
+
+  Copyright (c) 2017, Linaro Ltd. All rights reserved.<BR>
+
+  This program and the accompanying materials are licensed and made available
+  under the terms and conditions of the BSD License which accompanies this
+  distribution.  The full text of the license may be found at
+  http://opensource.org/licenses/bsd-license.php.
+
+  THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS, WITHOUT
+  WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
+
+**/
+
+#ifndef  _SYNQUACER_DRAMINFO_PPI_
+#define  _SYNQUACER_DRAMINFO_PPI_
+
+#define SYNQUACER_DRAMINFO_PPI_GUID \
+  { 0x3e1d7356, 0xdda4, 0x4b1a, { 0x93, 0x46, 0xbf, 0x89, 0x1c, 0x86, 0x46, 0xcc } }
+
+/**
+  Retrieve the number of discontiguous DRAM regions
+
+  @param[out] RegionCount       The number of available DRAM regions
+
+  @retval EFI_SUCCESS           The data was successfully returned.
+  @retval EFI_INVALID_PARAMETER RegionCount == NULL
+
+**/
+typedef
+EFI_STATUS
+(EFIAPI * DRAMINFO_GET_REGION_COUNT) (
+  OUT   UINTN                 *RegionCount
+  );
+
+/**
+  Retrieve the base and size of a DRAM region
+
+  @param[in]  RegionIndex       The 0-based index of the region to retrieve
+  @param[out] Base              The base of the requested region
+  @param[out] Size              The size of the requested region
+
+  @retval EFI_SUCCESS           The data was successfully returned.
+  @retval EFI_INVALID_PARAMETER Base == NULL or Size == NULL
+  @retval EFI_NOT_FOUND         No region exists with index >= RegionIndex
+
+**/
+typedef
+EFI_STATUS
+(EFIAPI * DRAMINFO_GET_REGION) (
+  IN    UINTN                 RegionIndex,
+  OUT   UINT64                *Base,
+  OUT   UINT64                *Size
+  );
+
+typedef struct {
+  DRAMINFO_GET_REGION_COUNT   GetRegionCount;
+  DRAMINFO_GET_REGION         GetRegion;
+} SYNQUACER_DRAM_INFO_PPI;
+
+extern EFI_GUID gSynQuacerDramInfoPpiGuid;
+
+#endif
diff --git a/Silicon/Socionext/SynQuacer/Library/SynQuacerPlatformPeiLib/SynQuacerPlatformPeiLib.c b/Silicon/Socionext/SynQuacer/Library/SynQuacerPlatformPeiLib/SynQuacerPlatformPeiLib.c
new file mode 100644
index 000000000000..358dd5a91f08
--- /dev/null
+++ b/Silicon/Socionext/SynQuacer/Library/SynQuacerPlatformPeiLib/SynQuacerPlatformPeiLib.c
@@ -0,0 +1,123 @@
+/** @file
+*
+*  Copyright (c) 2011-2014, ARM Limited. All rights reserved.
+*
+*  This program and the accompanying materials
+*  are licensed and made available under the terms and conditions of the BSD License
+*  which accompanies this distribution.  The full text of the license may be found at
+*  http://opensource.org/licenses/bsd-license.php
+*
+*  THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
+*  WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
+*
+**/
+
+#include <PiPei.h>
+#include <Library/BaseMemoryLib.h>
+#include <Library/DebugLib.h>
+#include <Library/HobLib.h>
+#include <Library/MemoryAllocationLib.h>
+#include <Library/PcdLib.h>
+#include <Library/PeiServicesLib.h>
+#include <Platform/DramInfo.h>
+#include <Ppi/DramInfo.h>
+#include <Ppi/MemoryDiscovered.h>
+
+STATIC
+CONST DRAM_INFO *mDramInfo = (VOID *)(UINTN)FixedPcdGet64 (PcdDramInfoBase);
+
+/**
+  Retrieve the number of discontiguous DRAM regions
+
+  @param[out] RegionCount       The number of available DRAM regions
+
+  @retval EFI_SUCCESS           The data was successfully returned.
+  @retval EFI_INVALID_PARAMETER RegionCount == NULL
+
+**/
+STATIC
+EFI_STATUS
+EFIAPI
+GetDramRegionCount (
+  OUT   UINTN                 *RegionCount
+  )
+{
+  if (RegionCount == NULL) {
+    return EFI_INVALID_PARAMETER;
+  }
+
+  *RegionCount = mDramInfo->NumRegions;
+
+  return EFI_SUCCESS;
+}
+
+/**
+  Retrieve the base and size of a DRAM region
+
+  @param[in]  RegionIndex       The 0-based index of the region to retrieve
+  @param[out] Base              The base of the requested region
+  @param[out] Size              The size of the requested region
+
+  @retval EFI_SUCCESS           The data was successfully returned.
+  @retval EFI_INVALID_PARAMETER Base == NULL or Size == NULL
+  @retval EFI_NOT_FOUND         No region exists with index >= RegionIndex
+
+**/
+STATIC
+EFI_STATUS
+EFIAPI
+GetDramRegion (
+  IN    UINTN                 RegionIndex,
+  OUT   UINT64                *Base,
+  OUT   UINT64                *Size
+  )
+{
+  if (Base == NULL || Size == NULL) {
+    return EFI_INVALID_PARAMETER;
+  }
+
+  if (RegionIndex >= mDramInfo->NumRegions) {
+    return EFI_NOT_FOUND;
+  }
+
+  *Base = mDramInfo->Entry[RegionIndex].Base;
+  *Size = mDramInfo->Entry[RegionIndex].Size;
+
+  return EFI_SUCCESS;
+}
+
+STATIC SYNQUACER_DRAM_INFO_PPI mDramInfoPpi = {
+  GetDramRegionCount,
+  GetDramRegion
+};
+
+STATIC CONST EFI_PEI_PPI_DESCRIPTOR mDramInfoPpiDescriptor = {
+  EFI_PEI_PPI_DESCRIPTOR_PPI | EFI_PEI_PPI_DESCRIPTOR_TERMINATE_LIST,
+  &gSynQuacerDramInfoPpiGuid,
+  &mDramInfoPpi
+};
+
+EFI_STATUS
+EFIAPI
+PlatformPeim (
+  VOID
+  )
+{
+  EFI_STATUS      Status;
+
+  ASSERT (mDramInfo->NumRegions > 0);
+
+  //
+  // Record the first region into PcdSystemMemoryBase and PcdSystemMemorySize.
+  // This is the region we will use for UEFI itself.
+  //
+  Status = PcdSet64S (PcdSystemMemoryBase, mDramInfo->Entry[0].Base);
+  ASSERT_EFI_ERROR (Status);
+
+  Status = PcdSet64S (PcdSystemMemorySize, mDramInfo->Entry[0].Size);
+  ASSERT_EFI_ERROR (Status);
+
+  BuildFvHob (FixedPcdGet64 (PcdFvBaseAddress), FixedPcdGet32 (PcdFvSize));
+
+  return PeiServicesInstallPpi (&mDramInfoPpiDescriptor);
+}
diff --git a/Silicon/Socionext/SynQuacer/Library/SynQuacerPlatformPeiLib/SynQuacerPlatformPeiLib.inf b/Silicon/Socionext/SynQuacer/Library/SynQuacerPlatformPeiLib/SynQuacerPlatformPeiLib.inf
new file mode 100644
index 000000000000..70eb715d44e3
--- /dev/null
+++ b/Silicon/Socionext/SynQuacer/Library/SynQuacerPlatformPeiLib/SynQuacerPlatformPeiLib.inf
@@ -0,0 +1,50 @@
+#/** @file
+#
+#  Copyright (c) 2017, Linaro, Ltd. All rights reserved.
+#
+#  This program and the accompanying materials
+#  are licensed and made available under the terms and conditions of the BSD License
+#  which accompanies this distribution.  The full text of the license may be found at
+#  http://opensource.org/licenses/bsd-license.php
+#
+#  THE PROGRAM IS DISTRIBUTED UNDER THE BSD LICENSE ON AN "AS IS" BASIS,
+#  WITHOUT WARRANTIES OR REPRESENTATIONS OF ANY KIND, EITHER EXPRESS OR IMPLIED.
+#
+#**/
+
+[Defines]
+  INF_VERSION                    = 0x0001001A
+  BASE_NAME                      = SynQuacerPlatformPeiLib
+  FILE_GUID                      = 86537337-b62b-4dcd-846f-033a6a8355e0
+  MODULE_TYPE                    = BASE
+  VERSION_STRING                 = 1.0
+  LIBRARY_CLASS                  = PlatformPeiLib
+
+[Sources]
+  SynQuacerPlatformPeiLib.c
+
+[Packages]
+  ArmPkg/ArmPkg.dec
+  MdePkg/MdePkg.dec
+  MdeModulePkg/MdeModulePkg.dec
+  Silicon/Socionext/SynQuacer/SynQuacer.dec
+
+[LibraryClasses]
+  BaseMemoryLib
+  DebugLib
+  HobLib
+  MemoryAllocationLib
+  PcdLib
+  PeiServicesLib
+
+[FixedPcd]
+  gArmTokenSpaceGuid.PcdFvBaseAddress
+  gArmTokenSpaceGuid.PcdFvSize
+  gSynQuacerTokenSpaceGuid.PcdDramInfoBase
+
+[Ppis]
+  gSynQuacerDramInfoPpiGuid             ## PRODUCES
+
+[Pcd]
+  gArmTokenSpaceGuid.PcdSystemMemoryBase
+  gArmTokenSpaceGuid.PcdSystemMemorySize
diff --git a/Silicon/Socionext/SynQuacer/SynQuacer.dec b/Silicon/Socionext/SynQuacer/SynQuacer.dec
index c3adf85d3562..1249ce688600 100644
--- a/Silicon/Socionext/SynQuacer/SynQuacer.dec
+++ b/Silicon/Socionext/SynQuacer/SynQuacer.dec
@@ -18,3 +18,12 @@ [Defines]
 
 [Includes]
   Include
+
+[Guids]
+  gSynQuacerTokenSpaceGuid = { 0x4d04555b, 0xdfdc, 0x418a, { 0x8a, 0xab, 0x07, 0xce, 0xef, 0x46, 0x82, 0xbb } }
+
+[Ppis]
+  gSynQuacerDramInfoPpiGuid = { 0x3e1d7356, 0xdda4, 0x4b1a, { 0x93, 0x46, 0xbf, 0x89, 0x1c, 0x86, 0x46, 0xcc } }
+
+[PcdsFixedAtBuild]
+  gSynQuacerTokenSpaceGuid.PcdDramInfoBase|0|UINT64|0x00000001